package top.ninwoo.dbc.client.configure;


import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.concurrent.Executor;

@Configuration
@EnableAsync // 开启异步调用 多线程
public class AsyncTaskConfig{

    @Bean("taskExecutor")
    public Executor taskExecutor() {

        // 新建一个任务执行器
        ThreadPoolTaskExecutor taskExecutor = new ThreadPoolTaskExecutor();
        taskExecutor.setCorePoolSize(10);////核心线程池大小
        taskExecutor.setMaxPoolSize(30);// 设置最大的线程数量
        taskExecutor.setQueueCapacity(25);// 等待队列
        taskExecutor.initialize();// 如果不初始化，导致找不到执行器
        return taskExecutor;
    }


}

