package top.ninwoo.dbc.utils;

import top.ninwoo.dbc.api.po.FileSlice;
import top.ninwoo.dbc.api.po.FileSliceComputing;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ImageToArrayUtils {

   public static int rows = 1 ;

   //public static int sliceNum ;

    //将image读为BufferedImage
 /*   public static BufferedImage readImage(String fileName){
        //File file = new File(directoryInput+fileName);
        File file = new File(fileName);
        FileInputStream fis = null;
        BufferedImage image = null;
        try {
            fis = new FileInputStream(file);
            image = ImageIO.read(fis);
        } catch (Exception e) {
            if (fis != null) {
                try {
                    fis.close();
                } catch (IOException ioException) {
                    ioException.printStackTrace();
                }
            }
            throw new RuntimeException("文件读取错误" + e.getMessage());
        }
        return image;
    }*/

    public static List<byte[]> imageSplit(BufferedImage images, int sliceNum){

        //BufferedImage images = readImage(name);

        int cols = sliceNum / rows;

        // 计算每个小图的宽度和高度
        int chunkWidth = images.getWidth() / cols;
        int chunkHeight = images.getHeight() / rows;

        int count = 0;
        //BufferedImage imgs[] = new BufferedImage[chunks];
        BufferedImage imgs[] = new BufferedImage[sliceNum];
        for (int x = 0; x < rows; x++) {
            for (int y = 0; y < cols; y++) {
                //设置小图的大小和类型
                imgs[count] = new BufferedImage(chunkWidth, chunkHeight, images.getType());
                //写入图像内容
                Graphics2D gr = imgs[count++].createGraphics();
                gr.drawImage(images, 0, 0,
                        chunkWidth, chunkHeight,
                        chunkWidth* y, chunkHeight * x,
                        chunkWidth * y + chunkWidth,
                        chunkHeight * x + chunkHeight, null);
                gr.dispose();
            }
        }
        //将imgs[]转为相应的byte数组
        List<byte[]> byteList = new ArrayList<byte[]>();
        for (int i = 0; i < imgs.length; i++) {
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            try {
                ImageIO.write(imgs[i],"jpg",bos);
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                bos.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            byteList.add(bos.toByteArray());
        }
        // 输出小图
/*        for (int i = 0; i < imgs.length; i++) {
            try {
                ImageIO.write(imgs[i], "jpg", new File("F:\\images\\split\\image" + i + ".jpg"));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }*/
        return byteList;
    }

    //图片灰度化，同时将grayImage[]转为byte[]数组
    public static List<byte[]> grayImage(List<FileSlice> fileSliceList){

        BufferedImage images[] = new BufferedImage[fileSliceList.size()];
        BufferedImage grayImage[] = new BufferedImage[fileSliceList.size()];
        int[] width = new int[fileSliceList.size()];
        int[] height = new int[fileSliceList.size()];
        for (int i = 0; i < fileSliceList.size(); i++) {
            ByteArrayInputStream bis = new  ByteArrayInputStream(fileSliceList.get(i).getFileBytes());
            try {
                images[i] = ImageIO.read(bis);
                width[i] = images[i].getWidth();
                height[i] = images[i].getHeight();
                grayImage[i] = new BufferedImage(width[i], height[i], BufferedImage.TYPE_BYTE_GRAY);//重点，技巧在这个参数BufferedImage.TYPE_BYTE_GRAY
                for(int j= 0 ; j < width[i] ; j++){
                    for(int k = 0 ; k < height[i]; k++){
                        int rgb = images[i].getRGB(j, k);
                        grayImage[i].setRGB(j, k, rgb);
                    }
                }
                ImageIO.write(grayImage[i], "jpg", new File("\\tmp\\statics\\image" + i + ".jpg"));
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                bis.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        List<byte[]> byteList = new ArrayList<>();
        for (int i = 0; i < grayImage.length; i++) {
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            try {
                ImageIO.write(grayImage[i],"jpg",bos);
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                bos.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            byteList.add(bos.toByteArray());
        }
        return byteList;
    }

    //小图片灰度化后，进行合并
    public static BufferedImage imageMerge(List<FileSliceComputing> fileSliceComputingList, int sliceNum){
        //byte[]--->BufferedImage
        BufferedImage images[] = new BufferedImage[fileSliceComputingList.size()];
        for (int i = 0; i < fileSliceComputingList.size(); i++) {
            ByteArrayInputStream bis = new  ByteArrayInputStream(fileSliceComputingList.get(i).getFileBytes());
            try {
                images[i] = ImageIO.read(bis);
                //ImageIO.write(images[i], "jpg", new File("F:\\images\\grayImage\\image" + i + ".jpg"));
                ImageIO.write(images[i], "jpg", new File("\\tmp\\statics\\image" + i + ".jpg"));
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                bis.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        int cols = sliceNum/rows;

        int chunks = sliceNum;
        int chunkWidth, chunkHeight;
        int type;
        //读入小图
        File[] imgFiles = new File[chunks];
        for (int i = 0; i < chunks; i++) {
            //imgFiles[i] = new File("F:\\images\\grayImage\\image" + i + ".jpg");
            imgFiles[i] = new File("\\tmp\\statics\\image" + i + ".jpg");
        }

        //创建BufferedImage
        BufferedImage[] buffImages = new BufferedImage[chunks];
        for (int i = 0; i < chunks; i++) {
            try {
                buffImages[i] = ImageIO.read(imgFiles[i]);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        type = buffImages[0].getType();
        chunkWidth = buffImages[0].getWidth();
        chunkHeight = buffImages[0].getHeight();
        //设置拼接后图的大小和类型
        BufferedImage finalImg = new BufferedImage(chunkWidth * cols, chunkHeight * rows, type);
        //写入图像内容
        int num = 0;
        for (int i = 0; i < rows; i++) {
            for (int j = 0; j < cols; j++) {
                finalImg.createGraphics().drawImage(buffImages[num], chunkWidth * j, chunkHeight * i, null);
                num++;
            }
        }
        //输出拼接后的图像
/*        try {
            ImageIO.write(finalImg, "jpeg", new File("D:\\vx-ymwang\\images\\mergeImage\\finalImg.jpg"));
        } catch (IOException e) {
            e.printStackTrace();
        }*/
        return finalImg;
    }

}
