package top.ninwoo.weixingsim.dynamicNet;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Stack;

import static top.ninwoo.weixingsim.dynamicNet.CycleTopo.cycleTp;


/**
 * 求某一数据量下的最佳映射结果和业务处理时延
 * 输出最佳粒子的位置和适应度值
 * 目前只允许计算过程跨单时隙
 * @jthu
 */
public class DoMap {
	

    //最大权值
    static final int MAXWEIGHT = 10000*1000;

    /*
     * 业务参数
     */
    //数据量MB？
    static double D = 4;

    //子任务数
    static int c = 7; //8

    //子任务依赖关系 边
    static int[][] link = {{0, 0, 1, 2, 3, 4, 5}, {1, 2, 3, 4, 5, 5, 6}};//

    //固定映射任务数==起始任务+终止任务
    static final  int C_STABLE = 2;

    //实际需映射任务数
    static int n1 = c - C_STABLE;

    /*
     * 网络参数
     */
    //设备数
    static int num = 6;
    //设备计算能力参数s  GB/s
    static double[] nt = {1.112341341313, 0.5196272109574349, 0.675827555541419, 0.7637869915859579, 0.7998320296858645, 0.638652700648973,0.6396760676518485, 0.5615337810185533, 0.6356797503522186, 0.8266103444996542};  //30节点
    /*static double[] nt = {1.112341341313, 0.5196272109574349, 0.675827555541419, 0.7637869915859579, 0.7998320296858645,
            0.638652700648973, 0.6396760676518485, 0.5615337810185533, 0.6356797503522186, 0.8266103444996542, 0.6924037701405794,
            0.9371892689614395, 0.6949256728585527, 0.6212614126622614, 0.6318393608430264, 0.7494680794385384, 0.9983949989039682,
            0.5610722256465777, 0.6415780028672076, 0.9371892689, 0.5269659075274151, 0.8219152161388867, 0.5815463889106197,
            0.8431429542046349, 0.31386253514456774, 0.6045132365410817, 0.8102279249524735, 0.47057296148341216, 0.8529743685059654, 0.8177711194660409};  //30节点*/
    //时隙大小
    static double slot = 20*1000;
    //时隙数目
    static int slotnum;
    //网络节点数
    static int dev;
    //初始化时延偏移量
    //这里需要一个时钟输入
    static double testLatency = 0;

    //固定映射设备数==起始设备+终止设备
    static final  int N_STABLE = 2;
    //实际可映射设备数
    static int n2;
    //单时隙可映射设备数
    static int mapdev = num - N_STABLE ;
    /*
     * BPSO参数
     */
    //粒子群规模
    static int n = 1000;
    //种群迭代次数
    static int k = 500;
    //惯性权重，加速因子1，2
    static double s = 1.5; static int c1 = 1; static int c2 = 1;

    public static void main(String[] args) {
        doMapApp();
    }


    //节点最终分配结果
    public static int[] result = new int[c];
    //节点间最短路由
    public static Stack[] route = new Stack[link[0].length+1];
    //业务发起时刻
    public static long startT;
    //传输时延约束
    public static LinkedList<Double> list = new LinkedList<>();

    public static void doMapApp() {


        for (slotnum = 1;slotnum<=3;slotnum++){
            //slotnum = 3;
            dev = num*slotnum;//10个卫星节点，3个时隙，则共有10*3个卫星节点
            n2 = dev - N_STABLE*slotnum;//n2实际可映射的节点
            //组装最短路矩阵
            double[][] edgeWeight = WTEG();

            System.out.println("大矩阵是：");

            for (int i = 0; i < edgeWeight.length; i++) {
                for (int j = 0; j < edgeWeight[0].length; j++) {
                    System.out.print(edgeWeight[i][j]+"    ");
                }
                System.out.println();
            }
            //最短路由矩阵


            InterSlotDijstraV2 dijs = new InterSlotDijstraV2(num, slot);
            InterSlotDijstraV2.pathRecord pathRecord = dijs.dijstra(edgeWeight, testLatency);
            double[][] lt = pathRecord.pathWeight;
            for(int i = 0;i<lt.length;i++){
                for(int j = 0;j<lt.length;j++){
                    lt[i][j] *= D;
                }
            }
            /*System.out.println("最短路由");
            System.out.println(Arrays.deepToString(lt));*/
            for (int i = 0;i<nt.length;i++) {
                nt[i] = (D * 1000) / nt[i];
            }

        }
    }

    private static double[][] WTEG() {

        //获取当前3时隙拓扑
        /**
         * 先用SimpleDateFormat.parse() 方法将日期字符串转化为Date格式
         * 通过Date.getTime()方法，将其转化为毫秒数
         */
        String date = "2019-01-01 00-00-00";
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");//24小时制
        long time = 0;
        try {
            time = simpleDateFormat.parse(date).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        int slotKey = (int) ((((System.currentTimeMillis()-time)/20/1000)-1)%300+1);
        startT= ((System.currentTimeMillis()-time)/20000+1)*20000;
        HashMap<Integer, double[][]> cycleTp = cycleTp();
        //HashMap<Integer, double[][]> cycleTp = cycleTpE();


        //获得单时隙连接矩阵  0或MAXWEIGHT
        //等待下一时隙开始执行业务
/*        double[][] currentTp = cycleTp.get((slotKey)%300+1);
        double[][] slot1 = new double[num][num];*/

        double[][] currentTp = cycleTp.get((slotKey)%300+1);
        double[][] slot1 = new double[num][num]; //10*10的矩阵图
        System.out.println("1："+(slotKey)%300+1);
        for (int i = 0; i < currentTp.length; i++) {
            for (int j = 0; j < currentTp[0].length; j++) {
                System.out.print(currentTp[i][j]+" ");
            }
            System.out.println();
        }


        //int[][] slot1 = new int[num][num]; //10*10的矩阵图
/*        for(int i = 0;i<slot1.length;i++){
            for(int j = 0;j<slot1.length;j++){
                if (currentTp[i][j]==0.0){
                    if (i==j){
                        slot1[i][j]=0.0;
                    }else
                        slot1[i][j] = MAXWEIGHT;
                }else{
                    slot1[i][j] = 10e5/currentTp[i][j];
                }

            }
        }*/
        for(int i = 0;i<slot1.length;i++){
            for(int j = 0;j<slot1[0].length;j++){
                if (currentTp[i][j]==0){
                    if (i==j){
                        slot1[i][j]=0;
                    }else
                        slot1[i][j] = MAXWEIGHT;
                }else{
                    //slot1[i][j] = 10e5/currentTp[i][j];
                }

            }
        }
        /*System.out.println("第一个时隙的网络拓扑："+Arrays.deepToString(slot1));
        System.out.println(slot1.length);
        System.out.println(slot1[0].length);
        System.out.println("第一个时隙的网络拓扑：");
        for (int i = 0; i < slot1.length; i++) {
            for (int j = 0; j < slot1[0].length; j++) {
                System.out.print(slot1[i][j]+" ");
            }
            System.out.println();
        }*/

        currentTp = cycleTp.get((slotKey)%300+1);
        System.out.println("2:"+(slotKey)%300+2);
        double[][] slot2 = new double[num][num];
        for(int i = 0;i<slot2.length;i++){
            for(int j = 0;j<slot2.length;j++){
                if (currentTp[i][j]==0){
                    if (i==j){
                        slot2[i][j]=0.0;
                    }else
                        slot2[i][j] = MAXWEIGHT;
                }else {
                    slot2[i][j] = 10e5 / currentTp[i][j];
                }
            }
        }
        currentTp = cycleTp.get((slotKey)%300+1);
        double[][] slot3 = new double[num][num];
        for(int i = 0;i<slot3.length;i++){
            for(int j = 0;j<slot3.length;j++){
                if (currentTp[i][j]==0){
                    if (i==j){
                        slot3[i][j]=0.0;
                    }else
                        slot3[i][j] = MAXWEIGHT;
                }else {
                    slot3[i][j] = 10e5 / currentTp[i][j];
                }
            }
        }
        //生成相邻时隙矩阵
        double[][] neighbor = new double[num][num];
        for(int i = 0;i<neighbor.length;i++){
            for(int j = 0;j<neighbor.length;j++){
                if(i == j){
                    neighbor[i][j] = slot;
                }else{
                    neighbor[i][j] = MAXWEIGHT;
                }
            }
        }
        //生成其余时隙矩阵
        double[][] nonNeighbor = new double[num][num];
        for(int i = 0;i<nonNeighbor.length;i++){
            for(int j = 0;j<nonNeighbor.length;j++){
                nonNeighbor[i][j] = MAXWEIGHT;
            }
        }
        //组装连接矩阵
        double[][] edgeWeight = new double[dev][dev];
        for(int i = 0;i<edgeWeight.length;i++){
            for(int j = 0;j<edgeWeight.length;j++){
                if (i>=0 & i<num & j>=0 & j<num) {
                    edgeWeight[i][j] = slot1[i][j];
                }else if (i>=num & i<2*num & j>=num & j<2*num) {
                    edgeWeight[i][j] = slot2[i%num][j%num];
                }else if (i>=2*num & i<3*num & j>=2*num & j<3*num) {
                    edgeWeight[i][j] = slot3[i%num][j%num];
                }else if ((i>=0 & i<num & j>=num & j<2*num) || (i>=num & i<2*num & j>=2*num & j<3*num)){
                    edgeWeight[i][j] = neighbor[i%num][j%num];
                }else {
                    edgeWeight[i][j] = nonNeighbor[i%num][j%num];
                }

            }
        }
        return edgeWeight;
    }




}