package top.ninwoo.weixingsim.dynamicNet;

public class InterSlotDijstraV2 {
	
	public static void main(String[] args) {
	double [][] edgeWeight = new double[][] {
		{0, 96, 157, 100, MAXWEIGHT, MAXWEIGHT,MAXWEIGHT,MAXWEIGHT,MAXWEIGHT},
		{371, 0, 163, MAXWEIGHT, 100,MAXWEIGHT,MAXWEIGHT,MAXWEIGHT,MAXWEIGHT},
		{84, 395, 0, MAXWEIGHT, MAXWEIGHT, 100,MAXWEIGHT,MAXWEIGHT,MAXWEIGHT},
		{MAXWEIGHT,MAXWEIGHT,MAXWEIGHT, 0, 8, 1,100,MAXWEIGHT,MAXWEIGHT},
		{MAXWEIGHT,MAXWEIGHT,MAXWEIGHT, 5, 0, 1,MAXWEIGHT,100,MAXWEIGHT},
		{MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, 5, 5, 0,MAXWEIGHT,MAXWEIGHT,100},
		{MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, 0, 46, 83 },
		{MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, 25, 0, 55},
		{MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, MAXWEIGHT, 35, 18, 0}};
		int num  = 3;
		double slot = 100;
		double testLatency = 0;
		InterSlotDijstraV2 di = new InterSlotDijstraV2(num, slot);
		di.dijstra(edgeWeight, testLatency);
}


/*	//最短路矩阵
	double [][] pathWeight;

	//*/

	//设备数目
	int num;

	//时隙值
	double slot;

	//最大权值
	static final int MAXWEIGHT = 10000*1000;
	
	public InterSlotDijstraV2( int num, double slot) {
		// TODO Auto-generated constructor stub
		this.num = num;
		this.slot = slot;
	}

	//最短路径算法
	public pathRecord dijstra(double [][] edgeWeight, double testLatency) {

		pathRecord pathRecord = new pathRecord();
		//存放上一条路径
		pathRecord.lastHop = new int[edgeWeight.length][edgeWeight.length];
		//存放最短路径
		pathRecord.pathWeight = new double[edgeWeight.length][edgeWeight.length];

		for(int i = 0; i < edgeWeight.length; i++) {
			singlePointDijstra(edgeWeight, i, testLatency, pathRecord.lastHop[i], pathRecord.pathWeight[i]);

/*			for(int j = 0; j < edgeWeight.length; j++) {
				pathWeight[i][j] = singleRowWeight[j];
//				System.out.print(pathWeight[i][j]+""+'\t');
			}*/
//		System.out.println('\n');
		}

//		System.out.println(Arrays.deepToString(pathRecord.pathWeight));
		//上一跳路由矩阵
		/*System.out.println("上一跳路由矩阵");
		System.out.println(Arrays.deepToString(pathRecord.lastHop));*/
//		System.out.println(Arrays.deepToString(pathWeight));
		return pathRecord;
	}

	//单点最短路算法
	private double[] singlePointDijstra(double[][] edgeWeight, int point, double testLatency, int [] lastHopi, double [] pathWeighti) {
/*		//存放最短路径
		double [] singleRowWeight = new double [edgeWeight.length];*/


		//存放已求得最短路径节点
		boolean [] isVisited = new boolean[edgeWeight.length];
		//初始化
		for(int j = 0; j < edgeWeight.length; j++) {
			if(edgeWeight[point][j]!=MAXWEIGHT && edgeWeight[point][j]!=slot) {
				if((edgeWeight[point][j]+testLatency) <= slot) {
					pathWeighti[j] = edgeWeight[point][j] + testLatency;
				}else {
					pathWeighti[j] = MAXWEIGHT;
				}
			}else {
				pathWeighti[j] = edgeWeight[point][j];
			}
		}
		isVisited[point] = true;

		//遍历所有节点
		for(int j = 0; j < edgeWeight[point].length; j++) {
			//遍历下一节点
			int index = MAXWEIGHT;
			index = nextPoint(pathWeighti, index, isVisited, edgeWeight);
			if(index == MAXWEIGHT) {break;}
			isVisited[index] = true;
			//更新以下一节点中转的全局最短路
			pathWeighti = updateSRW(edgeWeight, pathWeighti, point, index, isVisited, lastHopi);
		}
		return pathWeighti;
	}

	//遍历下一节点
	private int nextPoint(double [] singleRowWeight, int index, boolean [] isVisited, double[][] edgeWeight) {
		
		double min = 0;
		for(int j = 0; j < edgeWeight.length; j++) {
			if(isVisited[j] == false) {
				if (singleRowWeight[j] != 0 && min == 0 && singleRowWeight[j] != MAXWEIGHT) {
					min = singleRowWeight[j];
					index = j;
				}
				if(singleRowWeight[j] < min) {
					min = singleRowWeight[j];
					index = j;
				}
			}
		}
		return index;
	}

	//更新以下一节点中转的全局最短路
	private double [] updateSRW(double[][] edgeWeight, double [] singleRowWeight,
			int point, int index, boolean [] isVisited, int [] lastHopi) {

		double temp = singleRowWeight[index];
		for(int k = 0; k < edgeWeight.length; k++) {
			if(isVisited[k] == false) {
				if ((index + num) == k) {
					if( (k/num-point/num)*slot < singleRowWeight[k]) {
						singleRowWeight[k] = (k/num-point/num)*slot;
						lastHopi[k] = index;
					}
				}else{
					if((temp + edgeWeight[index][k])<= (k/num-point/num+1)*slot && (temp + edgeWeight[index][k]) < singleRowWeight[k]) {
						singleRowWeight[k] = temp + edgeWeight[index][k];
						lastHopi[k] = index;
					}
				}
			}
		}
		return singleRowWeight;
	}

	class pathRecord{
		//最短路矩阵
		double [][] pathWeight;
		//上一跳矩阵
		int [][] lastHop;

		public pathRecord() {
		}
	}
}

