package top.ninwoo.tests;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import top.ninwoo.bishe.starter.service.ClusterService;
import top.ninwoo.bishe.starter.service.NetworkService;
import top.ninwoo.common.entity.*;
import top.ninwoo.weixingsim.WxMain;
import top.ninwoo.weixingsim.sateTopology.entity.SimData;
import top.ninwoo.weixingsim.sateTopology.entity.WeiXingData;
import top.ninwoo.weixingsim.sateTopology.service.impl.ToponetImpl;
import top.ninwoo.weixingsim.sateTopology.service.impl.WeixingImpl;

import javax.annotation.Resource;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = WxMain.class)
public class TopoTests {

    @Autowired
    private ClusterService clusterService;

    @Resource
    private NetworkService networkService;

    @Test


    public void test() throws IllegalAccessException, InterruptedException {
        ArrayList<SeparatedClusterConfig> clusterConfigs = new ArrayList<>();
        SeparatedClusterConfig separatedClusterConfig = new SeparatedClusterConfig();
        List<ContainerDescription> cds = new ArrayList<>();
        // TODO: 这个ID应该是从借口获取的
        separatedClusterConfig.setEdgeNodeId("192.168.31.198:18088");
        ClusterConfig clusterConfig = new ClusterConfig();
        clusterConfig.setId(11113l);
        clusterConfig.setOwner("joliu");

        //从文本中获取卫星的数据
        WeixingImpl wx = new WeixingImpl();
        ToponetImpl tp = new ToponetImpl();
        SimData sd = new SimData();
        //tp.delHistory();
        File file = new File("F:\\ymwang\\topusim_1.txt");
//        D:\LabratoryJavaPro\codingDownload\latestCoding\
        List<WeiXingData> wxData = wx.iniTopo(file, sd.getZhouqi());
        int[][] toponet = tp.getTopology(wxData, sd);


        //创建容器
/*        ContainerDescription containerDescription0 = new ContainerDescription();
        containerDescription0.setMode("normal");
        containerDescription0.setReplicas(1);

        DockerContainer container0 = new DockerContainer();
        container0.setName(wxData.get(0).getName());
        container0.setCommand("sh");
        container0.setImage("dbc_client");
        container0.setPorts("8999");//指定容器端口

        containerDescription0.setDockerContainer(container0);
        cds.add(containerDescription0);*/
        for (int k = 0; k < wxData.size()-1; k++) {
            ContainerDescription containerDescription = new ContainerDescription();
            containerDescription.setMode("normal");
            containerDescription.setReplicas(1);

            DockerContainer container = new DockerContainer();
            container.setName(wxData.get(k).getName());
            container.setCommand("sh");
            container.setImage("dbc_server");

            containerDescription.setDockerContainer(container);
            cds.add(containerDescription);
        }
        ContainerDescription containerDescription0 = new ContainerDescription();
        containerDescription0.setMode("normal");
        containerDescription0.setReplicas(1);

        DockerContainer container0 = new DockerContainer();
        container0.setName(wxData.get(wxData.size()-1).getName());
        container0.setCommand("sh");
        container0.setImage("dbc_client");
        container0.setPorts("8999");//指定容器端口

        containerDescription0.setDockerContainer(container0);
        cds.add(containerDescription0);
        /////////////////////////////////////////////
        clusterConfig.setDockers(cds);
        NetworkTopology topo = new NetworkTopology();
        topo.setAppNames(tp.getAppNames(wxData));
        // 这个参数好像没啥用
        topo.setTopologyId(11);
        topo.setTopology(toponet);
        clusterConfig.setTopology(topo);
        separatedClusterConfig.setClusterConfig(clusterConfig);
        clusterConfigs.add(separatedClusterConfig);

        clusterService.sendClusterConfigToEdgeNode(clusterConfigs);
    }

    //测试容器ip
    @Test
    public void getIpListByAppNameTest() {
        //List<String> ipList = networkService.getIpListByAppName(11112L, "sate2");

        //从文本中获取卫星的数据
        WeixingImpl wx = new WeixingImpl();
        ToponetImpl tp = new ToponetImpl();
        SimData sd = new SimData();
        //tp.delHistory();
        File file = new File("F:\\ymwang\\topusim_1.txt");
        List<WeiXingData> wxData = null;
        try {
            wxData = wx.iniTopo(file, sd.getZhouqi());
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }

        List<String> ipList = new ArrayList<>();
        for (int k = 1; k < wxData.size(); k++){
            String appName = wxData.get(k).getName();
            ipList.add(networkService.getIpListByAppName(11113L, appName).toString()) ;
        }

        //System.out.println("长度："+ipList.size());
    }

    @Test
    public void getIpList() {
        //List<String> ipListS = networkService.getIpListByAppName(11112L, "dfs_server");

        //从文本中获取卫星的数据
        WeixingImpl wx = new WeixingImpl();
        ToponetImpl tp = new ToponetImpl();
        SimData sd = new SimData();
        //tp.delHistory();
        File file = new File("F:\\ymwang\\topusim_1.txt");
        List<WeiXingData> wxData = null;
        try {
            wxData = wx.iniTopo(file, sd.getZhouqi());
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }

        List<String> ipListS = new ArrayList<>();
        for (int k = 1; k < wxData.size(); k++){
            String appName = wxData.get(k).getName();
            ipListS.add(networkService.getIpListByAppName(11113L, appName).toString()) ;
        }
        String[] ipList = new String[ipListS.size()];
        for (int i = 0; i < ipListS.size(); i++) {
            if(!ipListS.isEmpty()){
                String ip_tmp = ipListS.get(i);
                String rep = ip_tmp.replaceAll("[\\[\\]]","");
                String[] split_list = rep.split("/");
                ipList[i] = split_list[0];
            }
        }
        for (int j = 0; j < ipList.length; j++) {
            System.out.println(ipList[j]);
        }
    }


    @Test
    public void removeClusterFromEdgeNodeTest() {
        clusterService.removeClusterFromEdgeNode(11113L);
    }
}
