package top.ninwoo.commonapi.service;

import top.ninwoo.commonapi.po.FileSlice;
import top.ninwoo.commonapi.po.MergeResult;
import top.ninwoo.commonapi.po.SendResult;
import top.ninwoo.commonapi.po.SplitResult;

/**
 * @author ljo
 * 用于发送文件的接口
 */
public interface TransferService {
    /**
     * 文件切片
     * @param fileBytes
     * @param sliceNum 切片数量(经过冗余之后的数量)
     * @param origNum 原始数组切分的数量
     * @return
     */
    SplitResult fileSplit(byte[] fileBytes, int sliceNum, int origNum);

    /**
     * 切片聚合接口
     * @param splitResult
     * @param sliceNum 切片数量(经过冗余之后的数量)
     * @param sliceNum origNum 原始数组切分的数量
     * @return
     */
    MergeResult sliceMerge(SplitResult splitResult, int sliceNum, int origNum);

    /**
     * 切片发送服务
     * @param targetIp
     * @param fileSlice
     * @return
     */
    SendResult sendFileSlice(String targetIp, FileSlice fileSlice);

    /**
     * 指定地址的ip获取切片
     * @param targetIp
     * @param fileId
     * @param sliceId
     * @return
     */
    FileSlice getFileSlice(String targetIp, Long fileId, int sliceId);

}
