package top.ninwoo.app.dfs.client.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import top.ninwoo.app.dfs.client.service.FileService;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

@Controller
public class FileController {

    @Autowired
    private FileService fileService;

    /*文件上传*/
    // 访问路径为：http://ip:port/upload
    @RequestMapping(value = "/upload", method = RequestMethod.GET)
    public String upload() {
        return "fileUpload";
    }


    @RequestMapping(value = "/upload", method = RequestMethod.POST)
    @ResponseBody
    public String upload(@RequestParam("file") MultipartFile file, @RequestParam("fileId") Long fileId) {
        if (!file.isEmpty()) {
            try {
                //BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(new File(file.getOriginalFilename())));
                FileOutputStream out = new FileOutputStream(new File(file.getOriginalFilename()));
                byte[] bytes = file.getBytes();
                //发送切片
                fileService.sendFile(fileId,bytes);
                //out.write(file.getBytes());
                out.flush();
                out.close();
            } catch (FileNotFoundException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (IOException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            }
            return "上传成功！";
        } else {
            return "上传失败，因为文件是空的.";
        }
    }

     /*文件下载*/
    // 访问路径为：http://ip:port/upload
/*    @RequestMapping(value = "/view", method = RequestMethod.GET)
    public String download() {
        return "fileFind";
    }*/

    /*文件下载*/
    //访问路径为：http://ip:port/download?name=x.jpg&fileId=1111
    @RequestMapping("download")
    public String view(String name, Long fileId, Model model) {
        fileService.getFile(name, fileId);
        model.addAttribute("fileName", name);
        return "fileDownload";
    }


}
