package top.ninwoo.app.dfs.repository;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Repository;
import top.ninwoo.commonapi.po.FileSlice;

import java.io.*;
import java.util.Arrays;

@Repository
@Slf4j
public class FileSliceRepository {
    /*private static final String PATH = "E:\\code\\bs-app\\distributed-file-transfer\\output\\";*/
    private static final String PATH = "F:\\output\\";
    private static final int DEFAULT_LENGTH = 1000;
    public FileSlice getFileSlice(Long fileId, int sliceId) {
        FileSlice fileSlice = new FileSlice();
        fileSlice.setSliceId(sliceId);
        fileSlice.setFileId(fileId);
        fileSlice.setStart(0L);
        ByteArrayOutputStream out = null;
        try {
            InputStream in = new FileInputStream(PATH + fileId + "-" + sliceId + ".data");
            out = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024 * 4];
            int n = 0;
            while ((n = in.read(buffer)) != -1) {
                out.write(buffer, 0, n);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        byte[] bytes = Arrays.copyOf(out.toByteArray(), DEFAULT_LENGTH);
        fileSlice.setFileBytes(bytes);
        fileSlice.setSize(out.toByteArray().length);
        return fileSlice;
    }

    public void saveFileSlice(FileSlice slice) {
        OutputStream os = null;
        try {
            File file = new File(PATH + slice.getFileId() + "-" + slice.getSliceId() + ".data");
            file.createNewFile();
            os = new FileOutputStream(file);
            byte[] targetBytes = Arrays.copyOf(slice.getFileBytes(), slice.getSize());
            os.write(targetBytes);
            os.flush();
        } catch (Exception e) {
            log.error("save fileSlice Error:{}", e.getMessage());
        } finally {
            if (os != null) {
                try {
                    os.close();
                } catch (Exception e) {
                    log.error("file close error!");
                }
            }
        }
    }
}
