package top.ninwoo.cloudcenter.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
public class SwaggerConfig {
    @Bean
    public Docket createRestApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .pathMapping("/")
                .select()
                .apis(RequestHandlerSelectors.basePackage("top.ninwoo.cloudcenter.controller"))
                .paths(PathSelectors.any())
                .build().apiInfo(new ApiInfoBuilder().title("CNF云平台Swagger文档")
                        .description("由Swagger自动生成，仅限测试环境使用")
                        .version("1.0")
                        .contact(new Contact("joliu", "opengn.org", "ljo0412@live.com"))
                        .license("The Apache License")
                        .licenseUrl("http://git.opensource5g.org/xidiancos/cnf/-/blob/master/LICENSE")
                        .build());
    }
}
